# -*- coding: utf-8 -*-
#
# univention-printer-assignment
#  ucs module
# 
# Copyright 2013 Univention GmbH
#
# http://www.univention.de/
#
# All rights reserved.
#
# The source code of this program is made available
# under the terms of the GNU Affero General Public License version 3
# (GNU AGPL V3) as published by the Free Software Foundation.
#
# Binary versions of this program provided by Univention to you as
# well as other copyrighted, protected or trademarked materials like
# Logos, graphics, fonts, specific documentations and configurations,
# cryptographic keys etc. are subject to a license agreement between
# you and Univention and not subject to the GNU AGPL V3.
#
# In the case you use this program under the terms of the GNU AGPL V3,
# the program is provided in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public
# License with the Debian GNU/Linux or Univention distribution in file
# /usr/share/common-licenses/AGPL-3; if not, see
# <http://www.gnu.org/licenses/>.

import os
import stat

def handler(configRegistry, changes):

	krb5 = configRegistry.get("kerberos/realm", "dummy").lower()
	s3file = "/var/lib/samba/netlogon/univention-printer-assignment.vbs"
	s4file = "/var/lib/samba/sysvol/%s/scripts/univention-printer-assignment.vbs" % krb5

	removeAll = "0"
	debug = "0"
	if configRegistry.is_true("printer/assignment/removeall", False):
		removeAll = "1"
	if configRegistry.is_true("printer/assignment/debug", False):
		debug = "1"

	for fileName in [s3file, s4file]:

		# create netlogon paths
		path = os.path.dirname(fileName)
		if not os.path.isdir(path):
			os.makedirs(path)

	
		# create script
		fn = open(fileName, 'w')

		print >> fn, "' Warning: This file is auto-generated and might be overwritten by"
		print >> fn, "'          univention-config-registry."
		print >> fn, "'          Please edit the following file(s) instead:"
		print >> fn, "' Warnung: Diese Datei wurde automatisch generiert und kann durch"
		print >> fn, "'          univention-config-registry überschrieben werden."
		print >> fn, "'          Bitte bearbeiten Sie an Stelle dessen die folgende(n) Datei(en):"
		print >> fn, "'"
		print >> fn, "'       /etc/univention/templates/modules/univention-printer-assignment.py"
		print >> fn, ""
		print >> fn, ""
		print >> fn, 'Dim flagRemoveAllPrinters: flagRemoveAllPrinters = %s' % removeAll
		print >> fn, 'Dim showDebug: showDebug = %s' % debug
		print >> fn, ''
		print >> fn, 'Dim objWshShell'
		print >> fn, 'Dim objFileSys'
		print >> fn, 'Dim objWshNetwork'
		print >> fn, 'Dim defaultPrinterSet'
		print >> fn, ''
		print >> fn, 'Set objWshShell = CreateObject("WScript.Shell")'
		print >> fn, 'Set objFileSys = CreateObject("Scripting.FileSystemObject")'
		print >> fn, 'Set objWshNetwork = CreateObject("WScript.Network")'
		print >> fn, ''
		print >> fn, 'baseName = objFileSys.GetParentFolderName(Wscript.ScriptFullName)'
		print >> fn, 'hostName = objWshShell.ExpandEnvironmentStrings("%computername%")'
		print >> fn, 'printerList = objFileSys.BuildPath(baseName, "univention-printer-assignment")'
		print >> fn, 'printerList  = objFileSys.BuildPath(printerList, hostName & ".printerlist")'
		print >> fn, 'defaultPrinterSet = 0'
		print >> fn, ''
		print >> fn, "' remove if printers should be deleted before adding new ones"
		print >> fn, 'If flagRemoveAllPrinters = 1 Then'
		print >> fn, '    RemoveAllPrinters()'
		print >> fn, 'End if'
		print >> fn, ''
		print >> fn, "' add printers and set default printer (to first printer)"
		print >> fn, 'If objFileSys.FileExists(printerList) Then'
		print >> fn, '    set file = objFileSys.openTextFile(printerList)'
		print >> fn, '    do while file.AtEndOfStream <> True'
		print >> fn, '        items = split(file.ReadLine, ":")'
		print >> fn, '        printername = items(0)'
		print >> fn, '        for i = 1 to (UBound(items) - 1)'
		print >> fn, '            spooler = items(i)'
		print >> fn, '            printerpath = "\\\\" & spooler & "\\" & printername'
		print >> fn, '            if showDebug = 1 Then'
		print >> fn, '                wscript.echo "Adding printer " & printerpath'
		print >> fn, '            end if'
		print >> fn, '            objWshNetwork.AddWindowsPrinterConnection printerpath'
		print >> fn, '            if defaultPrinterSet = 0 then'
		print >> fn, '                defaultPrinterSet = 1'
		print >> fn, '                if showDebug = 1 Then'
		print >> fn, '                    wscript.echo "Set default printer to " & printerpath'
		print >> fn, '                end if'
		print >> fn, '                objWshNetwork.SetDefaultPrinter printerpath'
		print >> fn, '            end if'
		print >> fn, '        next'
		print >> fn, '    loop'
		print >> fn, '    file.close'
		print >> fn, '    set file = nothing'
		print >> fn, 'End If'
		print >> fn, ''
		print >> fn, "' remove all none local printers"
		print >> fn, 'sub RemoveAllPrinters()'
		print >> fn, '    dim oPrinters, aPrinter'
		print >> fn, '    Set objNetwork = WScript.CreateObject("Wscript.Network")'
		print >> fn, '    Set oPrinters = objNetwork.EnumPrinterConnections'
		print >> fn, '    For i = 0 to oPrinters.Count - 1 Step 2'
		print >> fn, '        on error resume next'
		print >> fn, '        aPrinter = split(uCase(oPrinters.Item(i+1)),"\\",-1, 1)'
		print >> fn, '        if not UBound(aPrinter) = 0 then'
		print >> fn, '            objNetwork.RemovePrinterConnection oPrinters.Item(i+1), True, True'
		print >> fn, '            If Err.Number = 0 Then'
		print >> fn, '                if showDebug = 1 Then'
		print >> fn, '                    wscript.echo "Success: Removed printer: " & oPrinters.Item(i+1)'
		print >> fn, '                End If'
		print >> fn, '            else'
		print >> fn, '                if showDebug = 1 Then'
		print >> fn, '                    wscript.echo "Failed:  Removing printer: " & oPrinters.Item(i+1)'
		print >> fn, '                end if'
		print >> fn, '            end if'
		print >> fn, '        end if'
		print >> fn, '    next'
		print >> fn, 'end sub'

		
		fn.close()
		os.chmod(fileName, (stat.S_IRWXU | stat.S_IRGRP |  stat.S_IXGRP | stat.S_IROTH | stat.S_IXOTH))
		os.chown(fileName, 0, 0)
